# Make Uhle

Dieses Repository enthält eine Webseite, die dazu verwendet wird, sich zur Make-AG der Uhlandshöhe zu registrieren. Es wird Rust, SQLx, und Axum verwendet, um eine Webanwendung zu entwickeln. Das Projekt verwendet SQLite als Datenbank und enthält bereits den entsprechenden Code. In diesem Readme erfährst du, wie du das Projekt auf deinem System einrichten und starten kannst.

## Voraussetzungen

Vor der Verwendung dieses Projekts musst du sicherstellen, dass die folgenden Softwarekomponenten auf deinem System installiert sind:

- Rust: Installiere Rust, indem du die offizielle Rust-Website besuchst oder einen Paketmanager wie `rustup` verwendest.
- sqlx-cli: Installiere sqlx-cli mit `cargo install sqlx-cli --features rustls`

## Setup

1. Klone das Repository auf deinen lokalen Computer:

   ```bash
   git clone https://git.uhle.cloud/dietrich/make_uhle.git
   ```

2. Navigiere in das Projektverzeichnis:

   ```bash
   cd make_uhle
   ```

3. Installiere die erforderlichen Abhängigkeiten und kompiliere das Projket:

   ```bash
   cargo build
   ```

4. (optional) Modifiziere die `.env`-Datei, sodass der Datenbankpfad deinen Wünschen entspricht. Wenn die Datei nicht existiert, wird sie automatisch erstellt (Ordner werden jedoch nicht angelegt).

5. Führe das SQLx-Setup aus, um die SQLite-Datenbank einzurichten:

   ```bash
   cargo sqlx setup
   ```

6. Die erstellte Binärdatei liegt in `target/debug/make_uhle`

## Starten der Anwendung

Sobald das Setup abgeschlossen ist, kannst du die Anwendung starten, indem du den folgenden Befehl ausführst:

```bash
cargo run
```

Die Anwendung wird gestartet und ist über die Adresse `http://localhost:8035` erreichbar.

## Beitrag leisten

Wenn du einen Fehler findest oder einen Beitrag zu diesem Projekt leisten möchtest, freuen wir uns über Pull Requests. Bitte erstelle einen Fork dieses Repositories, führe deine Änderungen durch und reiche dann einen Pull Request ein.

## Lizenz

Dieses Projekt ist unter der MIT-Lizenz lizenziert. Weitere Informationen findest du in der [Lizenzdatei](/dietrich/make_uhle/src/branch/main/LICENSE).